package org.dromara.elevator.service;

import org.dromara.elevator.domain.vo.EAnnualPlanVo;
import org.dromara.elevator.domain.bo.EAnnualPlanBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;

import java.time.LocalDate;
import java.util.Collection;
import java.util.List;
import java.util.Set;

/**
 * 年检计划;Service接口
 *
 * @author zy
 * @date 2024-09-03
 */
public interface IEAnnualPlanService {

    /**
     * 查询年检计划;
     *
     * @param id 主键
     * @return 年检计划;
     */
    EAnnualPlanVo queryById(Long id);

    /**
     * 分页查询年检计划;列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 年检计划;分页列表
     */
    TableDataInfo<EAnnualPlanVo> queryPageList(EAnnualPlanBo bo, PageQuery pageQuery);

    /**
     * 查询超期未年检数据
     * @param bo
     * @param pageQuery
     * @return
     */
    TableDataInfo<EAnnualPlanVo> overduePageList(EAnnualPlanBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的年检计划;列表
     *
     * @param bo 查询条件
     * @return 年检计划;列表
     */
    List<EAnnualPlanVo> queryList(EAnnualPlanBo bo);

    /**
     * 新增年检计划;
     *
     * @param bo 年检计划;
     * @return 是否新增成功
     */
    Boolean insertByBo(EAnnualPlanBo bo);

    /**
     * 修改年检计划;
     *
     * @param bo 年检计划;
     * @return 是否修改成功
     */
    Boolean updateByBo(EAnnualPlanBo bo);

    /**
     * 校验并批量删除年检计划;信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 获取年检日历
     * @return
     */
    Set<LocalDate> getDateList();

    /**
     * 根据日期获取电梯年检信息
     * @param planDate
     * @return
     */
    List<EAnnualPlanVo> getAnnualByDate(LocalDate planDate);
}
